/*
    PopupMenu.prg - Class(y) popup menu class

    Copyright (c) 1991 Chris Muller and Anton van Straaten
*/

#include "class(y).ch"


CREATE CLASS PopupMenu FROM BaseMenu
    VAR     width

PROTECTED:
    METHOD  initWin
    METHOD  menuTop, menuLeft

EXPORT:
    METHOD  addItem
    METHOD  childRow, childCol
END CLASS


// pass parameters up to superclass (will not be necessary in Class(y) 2.0)
CONSTRUCTOR new( aItems ), ( aItems )
RETURN


METHOD PROCEDURE initWin
    LOCAL bottom := ::menuTop + len( ::items ) + 1
    LOCAL right  := ::menuLeft + ::width + 1
    ::window := Window():new( ::menuTop, ::menuLeft, bottom, right, ::colorSpec )
    // display window and draw frame.
    ::window:show:frame()
RETURN


METHOD menuTop
RETURN ::parent:childRow()


METHOD menuLeft
RETURN ::parent:childCol()


METHOD childRow
RETURN ::window:top + ::currPos + 1


METHOD childCol
RETURN ::window:left + 1


METHOD PROCEDURE addItem( cLabel, oAction, isActive )
    LOCAL nRow
    LOCAL nItemNo := LEN( ::items ) + 1

    // establish relative screen row for new option
    IF nItemNo == 1
        nRow := 1
    ELSE
        nRow := ATail(::items):nextRow
    END

    ::addNewItem( nRow, 1, cLabel, oAction, isActive )

    IF ::width == NIL
        // initialize ::width here, since when addItem is invoked by BaseMenu's
        // constructor, the body of Menu's constructor has not yet executed.
        ::width := 0
    END

    ::width := MAX( ::width, ::items[nItemNo]:len )
RETURN


// eof popupmenu.prg
